using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Threading;
using System.Diagnostics;

namespace CopyPackage
{
    public delegate void OnCopyChunk(int step);

    public class CopyParam
    {
        public string src;
        public string dest;
        public OnCopyChunk del;
        public Thread Thread;
    }

    public static class FileCopy
    {
        private static int chunkSize;
        private static string source, destination;

        private static List<Thread> threadList = new List<Thread>();
        public static int ChunkSize
        {
            get { return chunkSize; }
            set { chunkSize = value; }
        }

        private static bool autoSize = true;

        public static bool AutoSize
        {
            get { return autoSize; }
            set { autoSize = value; }
        }

        public static int CopyFile(string src, string dest)
        {
            if (File.Exists(src))
            {
                source = src;
                destination = dest;
                Thread th = new Thread(new ThreadStart(copy));
                threadList.Add(th);
                th.Start();
                return th.ManagedThreadId;
            }
            return -1;
        }

        public static void StopCopy(int id)
        {
            Thread curThread = threadList.Find(delegate(Thread t) { return t.ManagedThreadId == id; });
            if (curThread != null)
            {
                curThread.Name = "FIN";
            }
        }

        private static void copy()
        {
            File.Copy(source, destination);
        }

        private static void copy2(object param)
        {
            CopyParam p = (CopyParam)param;
            FileInfo info = new FileInfo(p.src);  
            if (info.Exists)
            {
                BinaryReader r = new BinaryReader(File.Open(p.src, FileMode.Open));
                BinaryWriter w = new BinaryWriter(File.Open(p.dest, FileMode.Create));
                long size = info.Length / 100;
                byte[] buf = new byte[size];
                int i = 0;
                while ((buf = r.ReadBytes((int)size)).GetLength(0) != 0)
                {
                    w.Write(buf);
                    w.Flush();
                    if (p.del != null)
                    {
                        p.del.Invoke(i);
                    }
                    i++;
                    if (p.Thread.Name == "FIN")
                    {
                        r.Close();
                        w.Close();
                        File.Delete(p.dest);
                        break;
                    }
                }

                r.Close();
                w.Close();
            }

            Trace.WriteLine("Fin du thread");
        }

        public static int CopyFile(string str, string dest, OnCopyChunk del)
        {
            CopyParam param = new CopyParam();
            param.src = str;
            param.dest = dest;
            param.del = del;
            Thread th = new Thread(new ParameterizedThreadStart(copy2));
            param.Thread = th;
            th.Start(param);
            threadList.Add(th);
            return th.ManagedThreadId;
        }
    }
}
